hdu 4336 Card Collector
Posted 日拱一卒 功不唐捐
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了hdu 4336 Card Collector相关的知识,希望对你有一定的参考价值。
Card Collector
http://acm.hdu.edu.cn/showproblem.php?pid=4336
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Special Judge
Problem Description
In your childhood, do you crazy for collecting the
beautiful cards in the snacks? They said that, for example, if you collect all
the 108 people in the famous novel Water Margin, you will win an amazing award.
As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
Input
The first line of each test case contains one integer N
(1 <= N <= 20), indicating the number of different cards you need the
collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN
<= 1), indicating the possibility of each card to appear in a bag of snacks.
Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
Output
Output one number for each test case, indicating the
expected number of bags to buy to collect all the N different cards.
You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
Sample Input
1
0.1
2
0.1 0.4
Sample Output
10.000
10.500
Source
题意:
n类卡片,买一包零食可能得到一张卡片,可能没有,问最后集齐n类卡片期望买几包零食
题解:
每一包零食,有3种可能
1、没有卡片
2、有 没有收集过的卡片
3、有 已经收集了的卡片
将卡片拥有情况状态压缩成s,p[j]表示没有收集过的卡片的概率
dp[s]=1+ 没有卡的概率*dp[s]+ 收集过的卡片的概率和*dp[s] + Σ dp[(1<<j)|s]*p[j]
=1+ dp[s]*(没有卡的概率+收集过的卡片的概率和) + Σ dp[(1<<j)|s]*p[j]
=1+ dp[s]*(1-Σ p[j])+ Σ dp[(1<<j)|s]*p[j]
移项,dp[s]-dp[s]*(1-Σ p[j])= 1+ Σ dp[(1<<j)|s]*p[j]
∴dp[s]* Σ p[j]=1+ Σ dp[(1<<j)|s]*p[j]
∴ dp[s]= (1+ Σ dp[(1<<j)|s]*p[j])/ Σ p[j]
#include<cstdio> #include<cstring> using namespace std; int n; double p[20],dp[1<<20]; double sum1,sum2; int main() { while(scanf("%d",&n)!=EOF) { memset(dp,0,sizeof(dp)); for(int i=0;i<n;i++) scanf("%lf",&p[i]); for(int i=(1<<n)-2;i>=0;i--) { sum1=sum2=0; for(int j=0;j<n;j++) if(!((1<<j)&i)) { sum1+=p[j]; sum2+=dp[(1<<j)|i]*p[j]; } dp[i]=(sum2+1)/sum1; } printf("%.4lf\n",dp[0]); } }
以上是关于hdu 4336 Card Collector的主要内容,如果未能解决你的问题,请参考以下文章
HDU 4336 Card Collector(状态压缩+概率DP)